/*  Project datactrl

	 Copyright  1993. All Rights Reserved.

	 SUBSYSTEM:    datactrl.exe Application
	 FILE:         Tbuffer.cpp
	 AUTHOR:       CALDERARA Serge


	 OVERVIEW
	 ========
	 Source file for implementation of RS_232 (TEdit).
*/

#include <owl\owlpch.h>
#include "tbuffer.h"
#include <stdio.h>
#include   <dos.h>
#pragma hdrstop



//===============================================
// Function: TCircBuffer
// Purpose : class constructor form1
//===============================================
TCircBuffer::TCircBuffer (int Buff_Size)
{
	BuffLen = Buff_Size;
	iWidx=0;
	iRidx=0;
	InitInstance();


}

//===============================================
// Function: TCircBuffer
// Purpose : class constructor form 2
//===============================================
TCircBuffer::TCircBuffer (TEditFile *tf,int Buff_Size,BOOL Debug)
{
	BuffLen = Buff_Size;
	iWidx=0;
	iRidx=0;
	DebugSt=Debug;
	teditfile=tf;
	InitInstance();


}



//===============================================
// Function: TCircBuffer
// Purpose : class destructor
//===============================================
TCircBuffer::~TCircBuffer ()
{
	 delete [] CircBuff;
	 delete [] sTime;
}


//===============================================
// Function: InitInstance
// Purpose : object initialisation
// Param   : none
// Return  : void
//===============================================
void TCircBuffer::InitInstance()
{
	CircBuff = new char[BuffLen];    // dynamic object buffer memory allocation
	sTime=new char [20];
	pWrite = CircBuff;               // pointer initialisation to start
	pRead = CircBuff;               // of buffer

	pEndOfBuff = CircBuff + (BuffLen-1);
	Clear(CircBuff,BuffLen); // clear circular buffer
	Clear(sTime,20);
}

//===============================================
// Function: WriteBuffer
// Purpose : Write coming data to buffer
// Param   : pointer to coming string
// Return  : void
//===============================================
char far* TCircBuffer::Write(int iLen,char *string)
{
	int j=0;    // index to coming string

	ReadTimeStamp(TFormat); // retrive time when data is coming
	string[iLen+1]='\0';

	do
	  {
		// Write pointer initialise to start of buffer when end is reached
		if (pWrite > pEndOfBuff) { pWrite = CircBuff;iWidx=0;}
		if ((pWrite - pRead)<0 && (pWrite > pRead))
		  {
			if (DebugSt==MD_DEBUG){teditfile->Insert("\r\nERROR : BUFFER OVERFLOW");}
			  else
					int iret=MessageBox(0L,"Buffer overflow","Buffer Error",MB_OK);

			 return NULL;
		  }

		*pWrite = string[j];
		pWrite++;
		iWidx++;
		j++;
		iLen--;
	  }while(iLen);

	// debug mode will display information
	if (DebugSt==MD_DEBUG) { ShowDebug(MD_DEBUG);}
	// end debug mode

	return CircBuff;
}


//===============================================
// Function: ReadBuffer
// Purpose : Read content of the buffer
// Param   : pointer to coming string
// Return  : void
//===============================================
char far* TCircBuffer::Read()
{
	int i=0;


	// retrieve size of data to read from buffer according to evaluation
	// of read and write pointer
	//string = (pWrite > pRead) ? new char[pWrite-pRead] : new char[(pEndOfBuff-pRead)+(pWrite-1)];
	string = new char[BuffLen+1];

	 do
	  {
		 if (pRead > pEndOfBuff) {pRead = CircBuff;iRidx=0;}

		 string[i] = *pRead;
		 pRead++;
		 iRidx++;
		 i++;
	  }while(pWrite-pRead);
  string[i]= END_OF_STRING;

  //pRead=pWrite; // if end of loop means that read pointer as reach write pointer

  if (ShowControl) {return ShowCrLf(string);}
		else
		 {
			// Begin of debug mode
			if (DebugSt==MD_DEBUG) { ShowDebug(0);}
			// End of debug mode
			return string;
		 }
}


//===============================================
// Function: ViewCrLf
// Purpose : build string with control character CR-LF
// Param   : comming string
// Return  : new string with CR-LF
//===============================================
char far* TCircBuffer::ShowCrLf(char *sCtrlString)
{

 int j=0;
 sCtrlString = new char [BuffLen+1];
 Clear(sCtrlString,BuffLen+1);

 for (int i=0;string[i]!='\x0';i++)
		 {

			if (string[i]== 0x0D) {
									  strcat(sCtrlString,"<CR>");
									  j=j+sizeof("<CR>")-1;
									}
			else
				if (string[i]== 0x0A) {
												  strcat(sCtrlString,"<LF>");
												  j=j+sizeof("<LF>")-1;
											  }
			  else

				{
				 sCtrlString[j]= string[i];
				 j++;
				}

		  }

  strcat(sCtrlString,"\r\n\0");
  return sCtrlString;
}



//===============================================
// Function: ClearBuffer
// Purpose : Clear content of the buffer pointed
//			  : by string
// Param   : pointer to buffer, size of buffer
// Return  : none
//===============================================
char* TCircBuffer::Clear(char *buff,int Len)
{

  for(int i=0;i<Len;i++)
	{buff[i]='\0';}
 return buff;
}


//===============================================
// Function: ShowDebug
// Purpose : Show buffer information on screen
// Param   : none
// Return  : void
//===============================================
void TCircBuffer::ShowDebug(BOOL Action)
{
	char far* sBuff=new char[255];
	char far* sTemp=new char [255];

	Clear(sBuff,255);
	Clear(sTemp,255);

	int j=0;

	if (Action==0)  // read operation
	{

		//sprintf(sBuff,"\r\nTCircBuffer class operation : READ");
		teditfile->Insert("\r\nTCircBuffer class operation : READ");

		for (int i=0;string[i]!='\x0';i++)
		 {

			if (string[i]== 0x0D) {
									  strcat(sTemp,"<CR>");
									  j=j+sizeof("<CR>")-1;
									}
			else
				if (string[i]== 0x0A) {
												  strcat(sTemp,"<LF>");
												  j=j+sizeof("<LF>")-1;
											  }
			  else

				{
				 sTemp[j]= string[i];
				 j++;
				}

		  }

			sTemp[j]=END_OF_STRING;
			sprintf(sBuff,"\r\n\tString : %s\r\n",sTemp);
			teditfile->Insert(sBuff);

			sprintf(sBuff,"\tNext read position : %d\r\n\0",iRidx);
			teditfile->Insert(sBuff);
			sprintf(sBuff,"\tBuffer size : %d bytes\r\n\0",BuffLen);
			teditfile->Insert(sBuff);
			teditfile->Insert("\tScreen output : ");


	}

	 else   // write operation
		{
			//sprintf(sBuff,"\r\nTCircBuffer class operation : WRITE");
			teditfile->Insert("\r\nTCircBuffer class operation : WRITE");

		for (int i=iRidx;i!=iWidx;i++)
		 {
			// verify the end of buffer
			if (i >= BuffLen) {i=0;}
			if (CircBuff[i]== 0x0D) {
									  strcat(sTemp,"<CR>");
									  j=j+sizeof("<CR>")-1;
									}
			else
				if (CircBuff[i]== 0x0A) {
												  strcat(sTemp,"<LF>");
												  j=j+sizeof("<LF>")-1;
											  }
			  else

				{
				 sTemp[j]= CircBuff[i];
				 j++;
				}

		  }

			sTemp[j]=END_OF_STRING;
			sprintf(sBuff,"\r\n\tString : %s\r\n",sTemp);
			teditfile->Insert(sBuff);

			sprintf(sBuff,"\tNext write position : %d\r\n\0",iWidx);
			teditfile->Insert(sBuff);
			sprintf(sBuff,"\tBuffer size : %d bytes\r\n\0",BuffLen);
			teditfile->Insert(sBuff);

		}

  delete [] sBuff;
  delete [] sTemp;
}


//===============================================
// Function: ReadTime
// Purpose : Get time of coming data
// Param   : Time format
// Return  : Time string pointer
//===============================================
char far* TCircBuffer::ReadTime(UINT TFormat)
{
	ReadTimeStamp(TFormat);
	return sTime;
}


//===============================================
// Function: ReadTimeStamp
// Purpose : Get time of coming data
// Param   : none
// Return  : void
//===============================================
void TCircBuffer::ReadTimeStamp(UINT TimeMode)
{
	struct  time t;

	gettime(&t);
	switch (TimeMode)
	{
		  case T_HH_MN_SS_MS:
				 sprintf(sTime,"%2d:%02d:%02d.%03d:\t",t.ti_hour, t.ti_min, t.ti_sec, t.ti_hund);
				 break;

		  case T_MN_SS_MS:
				 sprintf(sTime,"%02d:%02d.%03d:\t",t.ti_min, t.ti_sec, t.ti_hund);
				 break;

		  case T_SS_MS:
				 sprintf(sTime,"%02d.%03d\t",t.ti_sec, t.ti_hund);
				 break;

		  case T_MS:
				 sprintf(sTime,"%03d ms\t",t.ti_hund);
				 break;
	}


}
