#if !defined(__TBuffer_h)              // Sentry, use file only if it's not already included.
#define __TBuffer_h

/*  Project datactrl

	 Copyright  1993. All Rights Reserved.

	 SUBSYSTEM:    datactrl.exe Application
	 FILE:         TBuffer.h
	 AUTHOR:       CALDERARA Serge


	 OVERVIEW
	 ========
	 Class definition for TCircBuffer.
*/

#include <owl\owlpch.h>
#include <owl\editfile.h>
#pragma hdrstop

#define MD_DEBUG	1
#define MD_RUN		0

#define T_HH_MN_SS_MS	0
#define T_MN_SS_MS		1
#define T_SS_MS			2
#define T_MS				3

const END_OF_STRING = '\0';

class TCircBuffer {
public:

	 TCircBuffer(int Size=1024);
	 TCircBuffer(TEditFile *tf,int Size=1024,BOOL Debug=TRUE);
	 virtual ~TCircBuffer ();

	 // buffer function definition
	 char far* Write(int Len,char *string); 				  // write buffer
	 char far* Read();                      				  // read buffer

	 inline char far* Clear(char *buff,int Len);			  // clear buffer
	 inline char far* GetWritePos(){return pWrite;}      // get write position
	 inline char far* GetReadPos(){return pRead;}        // get read position
	 inline char far* GetEndPos(){return pEndOfBuff;}    // get end position
	 inline char far* ReadTime(UINT TFormat);					// get time format string
	 inline void ViewCrLf(BOOL View){ShowControl=View;}
	 inline void SetDebugMode(UINT Debug){DebugSt=Debug;}


private:


		 TEditFile *teditfile;

		 char far *pWrite;     // write pointer definition
		 char far *pRead;      // read pointer definition
		 char far *CircBuff;   // circular buffer
		 char far *pEndOfBuff; // End of buffer pointer
		 char far *string;     // read string from buffer
		 char far *sTime;

		 int BuffLen;      // buffer dimension
		 int iWidx;        // value used to get write pointer index
		 int iRidx;			 // value used to get read pointer index

		 UINT DebugSt;     // Debug mode status
		 UINT TFormat;		 // time format
		 BOOL ShowControl; // view control char CR-LF

		 void InitInstance(); //initialisation of all object instance
		 void ShowDebug(BOOL Operation);
		 void inline ReadTimeStamp(UINT TimeMode);
		 char far* ShowCrLf(char far* s);
};    //End TCircBuffer

#endif


